%define section free
%define base_name cactus
%define cactus_version 1.5

Summary:        Cactus unit test framework for server-side java code 
Name:           jakarta-%{base_name}
Version:        %{cactus_version}
Release:        1jpp
Epoch:          0
License:        Apache Software License
URL:            http://jakarta.apache.org/cactus/
Group:          Development/Libraries
Vendor:         JPackage Project
Distribution:   JPackage
Source0:        jakarta-cactus-src-1.5.zip
Source1:        cactus-missing-testinput.tar.gz
Patch0:         cactus-checkstyle.patch
Patch1:         cactus-noeclipse-build_xml.patch
BuildRequires:  ant >= 0:1.5.4
BuildRequires:  jpackage-utils >= 0:1.5.32
BuildRequires:  junit >= 0:3.8.1
BuildRequires:  antlr >= 0:2.7.2
BuildRequires:  aspectj >= 0:1.1.1
BuildRequires:  checkstyle >= 0:3.3
BuildRequires:  clover >= 0:1.2.4
BuildRequires:  httpunit >= 0:1.5.4
BuildRequires:  j2sdkee-1.2-sun >= 0:1.2.1
BuildRequires:  j2sdkee-1.3-sun >= 0:1.3.1
BuildRequires:  jasper4 >= 0:4.1.29
BuildRequires:  jetty4 >= 0:4.2.17
BuildRequires:  jakarta-commons-beanutils >= 0:1.6.1
BuildRequires:  jakarta-commons-collections >= 0:2.1
BuildRequires:  jakarta-commons-httpclient >= 0:2.0
BuildRequires:  jakarta-commons-logging >= 0:1.0.3
BuildRequires:  jakarta-taglibs-standard >= 0:1.1.0
BuildRequires:  log4j >= 0:1.2.8
BuildRequires:  mockobjects >= 0:0.09
BuildRequires:  nekohtml >= 0:0.8.3
BuildRequires:  regexp >= 0:1.3
BuildRequires:  servletapi3 >= 0:3.3.1
BuildRequires:  servletapi4 >= 0:4.0.4
BuildRequires:  xerces-j2 >= 0:2.6.0
BuildRequires:  xml-commons-apis >= 0:1.0
Requires:  antlr >= 0:2.7.2
Requires:  aspectj >= 0:1.1.1
Requires:  checkstyle >= 0:3.3
Requires:  clover >= 0:1.2.4
Requires:  httpunit >= 0:1.5.4
Requires:  j2sdkee-1.2-sun >= 0:1.2.1
Requires:  j2sdkee-1.3-sun >= 0:1.3.1
Requires:  jasper4 >= 0:4.1.29
Requires:  jetty4 >= 0:4.2.17
Requires:  jakarta-commons-beanutils >= 0:1.6.1
Requires:  jakarta-commons-collections >= 0:2.1
Requires:  jakarta-commons-httpclient >= 0:2.0
Requires:  jakarta-commons-logging >= 0:1.0.3
Requires:  jakarta-taglibs-standard >= 0:1.1.0
Requires:  log4j >= 0:1.2.8
Requires:  mockobjects >= 0:0.09
Requires:  nekohtml >= 0:0.8.3
Requires:  regexp >= 0:1.3
Requires:  servletapi3 >= 0:3.3.1
Requires:  servletapi4 >= 0:4.0.4
Requires:  xerces-j2 >= 0:2.6.0
Requires:  xml-commons-apis >= 0:1.0
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
Cactus is a simple test framework for unit testing 
server-side java code (Servlets, EJBs, Tag Libs, 
Filters, ...). The intent of Cactus is to lower the 
cost of writing tests for server-side code. It uses 
JUnit and extends it. Cactus implements an 
in-container strategy 

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.

%package manual
Summary:        Docs for %{name}
Group:          Development/Documentation

%description manual
Docs for %{name}.

# -----------------------------------------------------------------------------

%prep
%setup -T -c -n %{name}-src-%{version}
cd ..
unzip -q %{SOURCE0}
cd %{name}-src-%{version}
chmod -R go=u-w *
gzip -dc %{SOURCE1} | tar -xf -

%patch0
%patch1

%build
(
cat << B_PROPS
antlr.jar = $(find-jar antlr)
aspectjrt.jar = $(find-jar aspectjrt)
aspectj-tools.jar = $(find-jar aspectjtools)
checkstyle.jar = $(find-jar checkstyle)
clover.jar = $(find-jar clover)
httpunit.jar = $(find-jar httpunit)
commons.beanutils.jar = $(find-jar commons-beanutils)
commons.collections.jar = $(find-jar commons-collections)
commons.httpclient.jar = $(find-jar jakarta-commons-httpclient)
commons.logging.jar = $(find-jar commons-logging)
j2ee.jar = $(find-jar j2ee-1.3)
j2ee.12.jar = $(find-jar j2ee-1.2)
j2ee.13.jar = $(find-jar j2ee-1.3)
jstl.jar = $(find-jar jakarta-taglibs-standard)
standard.jar = $(find-jar jakarta-taglibs-standard)
jasper-compiler.jar = $(find-jar jasper4-compiler)
jasper-runtime.jar = $(find-jar jasper4-runtime)
jetty.jar = $(find-jar jetty4)
junit.jar = $(find-jar junit)
log4j.jar = $(find-jar log4j)
mockobjects.jar = $(find-jar mockobjects-core)
nekohtml.jar = $(find-jar nekohtml)
regexp.jar = $(find-jar regexp)
servlet.jar = $(find-jar servletapi4)
servlet.22.jar = $(find-jar servletapi3)
servlet.23.jar = $(find-jar servletapi4)
xerces.jar = $(find-jar xerces-j2)
xmlapis.jar = $(find-jar xml-commons-apis)
B_PROPS
) > build.properties

echo offline = true > documentation/build.properties

export CLASSPATH=$(build-classpath \
ant \
ant-optional \
clover \
taglibs-core \
taglibs-standard \
junit)
ant -Dbuild.sysclasspath=first

# -----------------------------------------------------------------------------

%install
rm -rf $RPM_BUILD_ROOT

# jars

install -dm 755 $RPM_BUILD_ROOT%{_javadir}/cactus-12
cp -p framework/dist-12/lib/cactus-1.5.jar \
         $RPM_BUILD_ROOT%{_javadir}/cactus-12/jakarta-cactus-1.5.jar
cp -p framework/dist-12/lib/cactus-1.5-clover.jar \
         $RPM_BUILD_ROOT%{_javadir}/cactus-12/jakarta-cactus-clover-1.5.jar
cp -p integration/ant/dist-12/lib/cactus-ant-1.5.jar \
         $RPM_BUILD_ROOT%{_javadir}/cactus-12/jakarta-cactus-ant-1.5.jar
cp -p integration/ant/dist-12/lib/cactus-ant-1.5-clover.jar \
         $RPM_BUILD_ROOT%{_javadir}/cactus-12/jakarta-cactus-ant-clover-1.5.jar
(cd $RPM_BUILD_ROOT%{_javadir}/cactus-12 && for jar in %{name}*-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|jakarta-||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/cactus-12 && for jar in %{base_name}*-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

install -dm 755 $RPM_BUILD_ROOT%{_javadir}/cactus-13
cp -p framework/dist-13/lib/cactus-1.5.jar \
         $RPM_BUILD_ROOT%{_javadir}/cactus-13/jakarta-cactus-1.5.jar
cp -p framework/dist-13/lib/cactus-1.5-clover.jar \
         $RPM_BUILD_ROOT%{_javadir}/cactus-13/jakarta-cactus-clover-1.5.jar
cp -p integration/ant/dist-13/lib/cactus-ant-1.5.jar \
         $RPM_BUILD_ROOT%{_javadir}/cactus-13/jakarta-cactus-ant-1.5.jar
cp -p integration/ant/dist-13/lib/cactus-ant-1.5-clover.jar \
         $RPM_BUILD_ROOT%{_javadir}/cactus-13/jakarta-cactus-ant-clover-1.5.jar
(cd $RPM_BUILD_ROOT%{_javadir}/cactus-13 && for jar in %{name}*-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|jakarta-||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/cactus-13 && for jar in %{base_name}*-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# javadoc
install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/clover-12
install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/clover-13
cp -pr documentation/dist/doc/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr documentation/dist/doc/clover-12/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/clover-12
cp -pr documentation/dist/doc/clover-13/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/clover-13
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf documentation/dist/doc/api
rm -rf documentation/dist/doc/clover-12
rm -rf documentation/dist/doc/clover-13

# manual
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp LICENSE.cactus $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr documentation/dist/doc/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

# -----------------------------------------------------------------------------

%clean
rm -rf $RPM_BUILD_ROOT

# -----------------------------------------------------------------------------

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

# -----------------------------------------------------------------------------

%files
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{version}/LICENSE.cactus
%{_javadir}

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{version}

# -----------------------------------------------------------------------------

%changelog
* Wed Feb 18 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.5-1jpp
- First JPackage release
